import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'aSR.m.dart';


class ASRService extends JsonRpcClientBase {
	ASRService(
		String host, {
		String serviceName = "IASRService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => ASRResultDTO.fromJson(map));
	}

	Future<ASRResultDTO> commitASRInfoAsync(CommitASRInfoRequest request) async {
		var rpcRst = await call("CommitASRInfoAsync", request);
		var result = ASRResultDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

}

