import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'chatMessage.m.dart';

import 'liveConsultation.m.dart';


class ChatMessageService extends JsonRpcClientBase {
	ChatMessageService(
		String host, {
		String serviceName = "IChatMessageService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => PageResult<ChatMessagesDTO>.fromJson(map));
		FJsonConvert.setDecoder((map) => ChatMessagesDTO.fromJson(map));
	}

	Future<PageResult<ChatMessagesDTO>> getChatMessagePagesAsync(GetChatMessagePageRequest request) async {
		var rpcRst = await call("GetChatMessagePagesAsync", request);
		var result = PageResult<ChatMessagesDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<PageResult<ChatMessagesDTO>> getChatMessagePagesVisitorAsync(GetChatMessagePageVisitorRequest request) async {
		var rpcRst = await call("GetChatMessagePagesVisitorAsync", request);
		var result = PageResult<ChatMessagesDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<ChatMessagesDTO> sendChatMessageAsync(SendChatMessageRequest request) async {
		var rpcRst = await call("SendChatMessageAsync", request);
		var result = ChatMessagesDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<ChatMessagesDTO> sendVisitChatMessageAsync(SendVisitChatMessageRequest request) async {
		var rpcRst = await call("SendVisitChatMessageAsync", request);
		var result = ChatMessagesDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

}

