import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';

import 'dongle.m.dart';

import 'researchEdition.m.dart';


class DongleService extends JsonRpcClientBase {
	DongleService(
		String host, {
		String serviceName = "IDongleService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				);

	Future<String> readDongleIdAsync(TokenRequest request) async {
		var rpcRst = await call("ReadDongleIdAsync", request);
		return rpcRst;
	}

	Future<bool> rewriteServerDongleAsync(RewriteServerDongleRequest request) async {
		var rpcRst = await call("RewriteServerDongleAsync", request);
		return rpcRst;
	}

	Future<bool> reportServerInfoAsync(ReportServerInfoRequest request) async {
		var rpcRst = await call("ReportServerInfoAsync", request);
		return rpcRst;
	}

}

