import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'exam.m.dart';

import 'liveConsultation.m.dart';
import 'vitalHealthExamBooking.m.dart';
import 'report.m.dart';


class ExamService extends JsonRpcClientBase {
	ExamService(
		String host, {
		String serviceName = "IExamService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => PageResult<RegisterInfoDTO>.fromJson(map));
		FJsonConvert.setDecoder((map) => RegisterInfoDTO.fromJson(map));
		FJsonConvert.setDecoder((map) => RegisterPersonInfoDTO.fromJson(map));
		FJsonConvert.setDecoder((map) => GetExamInfoByPhysicalExamNumberResult.fromJson(map));
		FJsonConvert.setDecoder((map) => ReportDTO2.fromJson(map));
		FJsonConvert.setDecoder((map) => PageResult<ExamTileConslusionDTO>.fromJson(map));
		FJsonConvert.setDecoder((map) => ExamTileConslusionDTO.fromJson(map));
	}

	Future<PageResult<RegisterInfoDTO>> getRegisterInfoPageAsync(GetRegisterInfoPageRequest request) async {
		var rpcRst = await call("GetRegisterInfoPageAsync", request);
		var result = PageResult<RegisterInfoDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<RegisterPersonInfoDTO> getRegisterInfoByPhysicalExamNumberAsync(GetRegisterInfoByPhysicalExamNumberRequest request) async {
		var rpcRst = await call("GetRegisterInfoByPhysicalExamNumberAsync", request);
		var result = RegisterPersonInfoDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<GetExamInfoByPhysicalExamNumberResult> getExamInfoByPhysicalExamNumberAsync(GetExamInfoByPhysicalExamNumberRequest request) async {
		var rpcRst = await call("GetExamInfoByPhysicalExamNumberAsync", request);
		var result = GetExamInfoByPhysicalExamNumberResult.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<List<ReportDTO2>> getVitalReportInfoAsync(GetVitalReportInfoRequest request) async {
		var rpcRst = await call("GetVitalReportInfoAsync", request);
		var result = (rpcRst as List).map((e)=>ReportDTO2.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

	Future<PageResult<ExamTileConslusionDTO>> getPatientExamByPageAsync(GetExamByPatientPageRequest request) async {
		var rpcRst = await call("GetPatientExamByPageAsync", request);
		var result = PageResult<ExamTileConslusionDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> uploadElectrocardiogramReportAsync(UploadElectrocardiogramReportRequest request) async {
		var rpcRst = await call("UploadElectrocardiogramReportAsync", request);
		return rpcRst;
	}

}

