import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'region.m.dart';


class RegionService extends JsonRpcClientBase {
	RegionService(
		String host, {
		String serviceName = "IRegionService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => RegionDTO.fromJson(map));
		FJsonConvert.setDecoder((map) => RegionDataItemDTO.fromJson(map));
	}

	Future<RegionDTO> getRegionsAsync(GetRegionsRequest request) async {
		var rpcRst = await call("GetRegionsAsync", request);
		var result = RegionDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<List<RegionDataItemDTO>> getRegionListAsync(GetRegionsRequest request) async {
		var rpcRst = await call("GetRegionListAsync", request);
		var result = (rpcRst as List).map((e)=>RegionDataItemDTO.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

}

