import 'notification.m.dart';
import 'researchEdition.m.dart';

class RegionDTO extends BaseDTO{
	String? regionVersion;
	String? languageType;
	String? reginData;

	RegionDTO({
		this.regionVersion,
		this.languageType,
		this.reginData,
		bool isDelete = false,
		DateTime? createTime,
		DateTime? updateTime,
	}) : super(
			isDelete: isDelete,
			createTime: createTime,
			updateTime: updateTime,
		);

	factory RegionDTO.fromJson(Map<String, dynamic> map) {
		return RegionDTO( 
			regionVersion: map['RegionVersion'],
			languageType: map['LanguageType'],
			reginData: map['ReginData'],
			isDelete: map['IsDelete'],
			createTime: map['CreateTime'] != null ? DateTime.parse(map['CreateTime']) : null,
			updateTime: map['UpdateTime'] != null ? DateTime.parse(map['UpdateTime']) : null,
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if (regionVersion != null)
			map['RegionVersion'] = regionVersion;
		if (languageType != null)
			map['LanguageType'] = languageType;
		if (reginData != null)
			map['ReginData'] = reginData;
		return map;
	}
}

class GetRegionsRequest {
	String? version;
	String? languageType;
	String? keyword;

	GetRegionsRequest({
		this.version,
		this.languageType,
		this.keyword,
	});

	factory GetRegionsRequest.fromJson(Map<String, dynamic> map) {
		return GetRegionsRequest( 
			version: map['Version'],
			languageType: map['LanguageType'],
			keyword: map['Keyword'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if (version != null)
			map['Version'] = version;
		if (languageType != null)
			map['LanguageType'] = languageType;
		if (keyword != null)
			map['Keyword'] = keyword;
		return map;
	}
}

class RegionDataItemDTO extends DataItemDTO{
	List<DataItemDTO>? children;

	RegionDataItemDTO({
		String? key,
		String? value,
		this.children,
	}) : super(
			key: key,
			value: value,
		);

	factory RegionDataItemDTO.fromJson(Map<String, dynamic> map) {
		return RegionDataItemDTO( 
			key: map['Key'],
			value: map['Value'],
			children: map['Children'] != null ? (map['Children'] as List).map((e)=>DataItemDTO.fromJson(e as Map<String,dynamic>)).toList() : null,
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if (children != null)
			map['Children'] = children;
		return map;
	}
}


