import 'patient.m.dart';
import 'notification.m.dart';
import 'liveConsultation.m.dart';
import 'researchEdition.m.dart';
import 'remedical.m.dart';
import 'education.m.dart';
import 'recordInfo.m.dart';
import 'organization.m.dart';

class VitalRecordInfoDTO {
	String? recordCode;
	RecordStatusEnum recordStatus;
	String? deviceCode;
	String? deviceName;
	String? languge;
	RemedicalListResult? remedicalListResult;
	List<ReportDTO>? reportInfos;

	VitalRecordInfoDTO({
		this.recordCode,
		this.recordStatus = RecordStatusEnum.NotScanned,
		this.deviceCode,
		this.deviceName,
		this.languge,
		this.remedicalListResult,
		this.reportInfos,
	});

	factory VitalRecordInfoDTO.fromJson(Map<String, dynamic> map) {
		return VitalRecordInfoDTO( 
			recordCode: map['RecordCode'],
			recordStatus: RecordStatusEnum.values.firstWhere((e) => e.index == map['RecordStatus']),
			deviceCode: map['DeviceCode'],
			deviceName: map['DeviceName'],
			languge: map['Languge'],
			remedicalListResult: map['RemedicalListResult'] != null ? RemedicalListResult.fromJson(map['RemedicalListResult']) : null,
			reportInfos: map['ReportInfos'] != null ? (map['ReportInfos'] as List).map((e)=>ReportDTO.fromJson(e as Map<String,dynamic>)).toList() : null,
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if (recordCode != null)
			map['RecordCode'] = recordCode;
		map['RecordStatus'] = recordStatus.index;
		if (deviceCode != null)
			map['DeviceCode'] = deviceCode;
		if (deviceName != null)
			map['DeviceName'] = deviceName;
		if (languge != null)
			map['Languge'] = languge;
		if (remedicalListResult != null)
			map['RemedicalListResult'] = remedicalListResult;
		if (reportInfos != null)
			map['ReportInfos'] = reportInfos;
		return map;
	}
}

class VitalGetRecordByNumberRequest extends TokenRequest{
	String? physicalExamNumber;

	VitalGetRecordByNumberRequest({
		this.physicalExamNumber,
		String? token,
	}) : super(
			token: token,
		);

	factory VitalGetRecordByNumberRequest.fromJson(Map<String, dynamic> map) {
		return VitalGetRecordByNumberRequest( 
			physicalExamNumber: map['PhysicalExamNumber'],
			token: map['Token'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if (physicalExamNumber != null)
			map['PhysicalExamNumber'] = physicalExamNumber;
		return map;
	}
}


