import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'role.m.dart';


class RoleService extends JsonRpcClientBase {
	RoleService(
		String host, {
		String serviceName = "IRoleService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => RoleDTO.fromJson(map));
	}

	Future<RoleDTO> getRoleByCodeAsync(GetRoleByCodeRequest request) async {
		var rpcRst = await call("GetRoleByCodeAsync", request);
		var result = RoleDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<List<RoleDTO>> findDefaultRolesAsync(FindDefaultRolesRequest request) async {
		var rpcRst = await call("FindDefaultRolesAsync", request);
		var result = (rpcRst as List).map((e)=>RoleDTO.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

	Future<List<RoleDTO>> findAuthenticationRolesAsync(FindAuthenticationRolesRequest request) async {
		var rpcRst = await call("FindAuthenticationRolesAsync", request);
		var result = (rpcRst as List).map((e)=>RoleDTO.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

	Future<List<RoleDTO>> findAllRolesAsync(FindAuthenticationRolesRequest request) async {
		var rpcRst = await call("FindAllRolesAsync", request);
		var result = (rpcRst as List).map((e)=>RoleDTO.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

}

