import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';

import 'task.m.dart';


class TaskService extends JsonRpcClientBase {
	TaskService(
		String host, {
		String serviceName = "ITaskService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				);

	Future<String> addTaskAsync(AddTaskRequest request) async {
		var rpcRst = await call("AddTaskAsync", request);
		return rpcRst;
	}

	Future<String> addJumpQueueTaskAsync(AddTaskRequest request) async {
		var rpcRst = await call("AddJumpQueueTaskAsync", request);
		return rpcRst;
	}

	Future<bool> cancelTaskAsync(StopTaskRequest request) async {
		var rpcRst = await call("CancelTaskAsync", request);
		return rpcRst;
	}

	Future<bool> stopTaskAsync(StopTaskRequest request) async {
		var rpcRst = await call("StopTaskAsync", request);
		return rpcRst;
	}

	Future<bool> continueTaskAsync(TaskRequest request) async {
		var rpcRst = await call("ContinueTaskAsync", request);
		return rpcRst;
	}

}

