import 'notification.m.dart';

class AddTaskRequest {
	VTaskType taskType;
	String? businessCode;
	String? jsonData;
	String? mainTaskCode;
	String? dBTaskCode;

	AddTaskRequest({
		this.taskType = VTaskType.Undefined,
		this.businessCode,
		this.jsonData,
		this.mainTaskCode,
		this.dBTaskCode,
	});

	factory AddTaskRequest.fromJson(Map<String, dynamic> map) {
		return AddTaskRequest( 
			taskType: VTaskType.values.firstWhere((e) => e.index == map['TaskType']),
			businessCode: map['BusinessCode'],
			jsonData: map['JsonData'],
			mainTaskCode: map['MainTaskCode'],
			dBTaskCode: map['DBTaskCode'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		map['TaskType'] = taskType.index;
		if (businessCode != null)
			map['BusinessCode'] = businessCode;
		if (jsonData != null)
			map['JsonData'] = jsonData;
		if (mainTaskCode != null)
			map['MainTaskCode'] = mainTaskCode;
		if (dBTaskCode != null)
			map['DBTaskCode'] = dBTaskCode;
		return map;
	}
}

class StopTaskRequest {
	String? taskCode;

	StopTaskRequest({
		this.taskCode,
	});

	factory StopTaskRequest.fromJson(Map<String, dynamic> map) {
		return StopTaskRequest( 
			taskCode: map['TaskCode'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if (taskCode != null)
			map['TaskCode'] = taskCode;
		return map;
	}
}

class TaskRequest {
	String? taskCode;

	TaskRequest({
		this.taskCode,
	});

	factory TaskRequest.fromJson(Map<String, dynamic> map) {
		return TaskRequest( 
			taskCode: map['TaskCode'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if (taskCode != null)
			map['TaskCode'] = taskCode;
		return map;
	}
}


