import 'notification.m.dart';
import 'liveConsultation.m.dart';
import 'education.m.dart';
import 'remedical.m.dart';
import 'researchEdition.m.dart';
import 'report.m.dart';

class AddEcgReportRequest extends TokenRequest{
	String? recordCode;
	String? reportDatasJson;
	String? patientName;
	String? reportTemplateCode;

	AddEcgReportRequest({
		this.recordCode,
		this.reportDatasJson,
		this.patientName,
		this.reportTemplateCode,
		String? token,
	}) : super(
			token: token,
		);

	factory AddEcgReportRequest.fromJson(Map<String, dynamic> map) {
		return AddEcgReportRequest( 
			recordCode: map['RecordCode'],
			reportDatasJson: map['ReportDatasJson'],
			patientName: map['PatientName'],
			reportTemplateCode: map['ReportTemplateCode'],
			token: map['Token'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if (recordCode != null)
			map['RecordCode'] = recordCode;
		if (reportDatasJson != null)
			map['ReportDatasJson'] = reportDatasJson;
		if (patientName != null)
			map['PatientName'] = patientName;
		if (reportTemplateCode != null)
			map['ReportTemplateCode'] = reportTemplateCode;
		return map;
	}
}

class ModifyEcgReportRequest extends AddEcgReportRequest{
	String? reportCode;

	ModifyEcgReportRequest({
		this.reportCode,
		String? recordCode,
		String? reportDatasJson,
		String? patientName,
		String? reportTemplateCode,
		String? token,
	}) : super(
			recordCode: recordCode,
			reportDatasJson: reportDatasJson,
			patientName: patientName,
			reportTemplateCode: reportTemplateCode,
			token: token,
		);

	factory ModifyEcgReportRequest.fromJson(Map<String, dynamic> map) {
		return ModifyEcgReportRequest( 
			reportCode: map['ReportCode'],
			recordCode: map['RecordCode'],
			reportDatasJson: map['ReportDatasJson'],
			patientName: map['PatientName'],
			reportTemplateCode: map['ReportTemplateCode'],
			token: map['Token'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if (reportCode != null)
			map['ReportCode'] = reportCode;
		return map;
	}
}


