import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vidProcess.m.dart';


class VidProcessService extends JsonRpcClientBase {
	VidProcessService(
		String host, {
		String serviceName = "IVidProcessService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => VidProcessResult.fromJson(map));
	}

	Future<VidProcessResult> convertToImageDataAsync(ConvertToImageDataRequest request) async {
		var rpcRst = await call("ConvertToImageDataAsync", request);
		var result = VidProcessResult.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<String> getThumbnailAsync(GetThumbnailRequest request) async {
		var rpcRst = await call("GetThumbnailAsync", request);
		return rpcRst;
	}

}

