import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalAnalyzeConfig.m.dart';

import 'researchEdition.m.dart';


class VitalAnalyzeConfigService extends JsonRpcClientBase {
	VitalAnalyzeConfigService(
		String host, {
		String serviceName = "IVitalAnalyzeConfigService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => AnalyzeConfigDTO.fromJson(map));
		FJsonConvert.setDecoder((map) => PageCollection<AnalyzeConfigDTO>.fromJson(map));
	}

	Future<String> createAnalyzeConfigAsync(CreateAnalyzeConfigRequest request) async {
		var rpcRst = await call("CreateAnalyzeConfigAsync", request);
		return rpcRst;
	}

	Future<AnalyzeConfigDTO> getAnalyzeConfigDetailAsync(GetAnalyzeConfigRequest request) async {
		var rpcRst = await call("GetAnalyzeConfigDetailAsync", request);
		var result = AnalyzeConfigDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<AnalyzeConfigDTO> getAnalyzeConfigDetailByKeyAsync(GetAnalyzeConfigByKeyRequest request) async {
		var rpcRst = await call("GetAnalyzeConfigDetailByKeyAsync", request);
		var result = AnalyzeConfigDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<PageCollection<AnalyzeConfigDTO>> getAnalyzeConfigPageAsync(AnalyzeConfigPageRequest request) async {
		var rpcRst = await call("GetAnalyzeConfigPageAsync", request);
		var result = PageCollection<AnalyzeConfigDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> removeAnalyzeConfigAsync(RemoveAnalyzeConfigRequest request) async {
		var rpcRst = await call("RemoveAnalyzeConfigAsync", request);
		return rpcRst;
	}

	Future<List<AnalyzeConfigDTO>> getAnalyzeConfigListAsync(GetAnalyzeConfigListRequest request) async {
		var rpcRst = await call("GetAnalyzeConfigListAsync", request);
		var result = (rpcRst as List).map((e)=>AnalyzeConfigDTO.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

	Future<bool> updateAnalyzeConfigAsync(UpdateAnalyzeConfigRequest request) async {
		var rpcRst = await call("UpdateAnalyzeConfigAsync", request);
		return rpcRst;
	}

}

