import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalContractTemplate.m.dart';

import 'researchEdition.m.dart';


class VitalContractTemplateService extends JsonRpcClientBase {
	VitalContractTemplateService(
		String host, {
		String serviceName = "IVitalContractTemplateService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => ContractTemplateDTO.fromJson(map));
		FJsonConvert.setDecoder((map) => PageCollection<ContractTemplateDTO>.fromJson(map));
	}

	Future<String> createContractTemplateAsync(CreateContractTemplateRequest request) async {
		var rpcRst = await call("CreateContractTemplateAsync", request);
		return rpcRst;
	}

	Future<ContractTemplateDTO> getContractTemplateDetailAsync(GetContractTemplateRequest request) async {
		var rpcRst = await call("GetContractTemplateDetailAsync", request);
		var result = ContractTemplateDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<ContractTemplateDTO> getContractTemplateDetailByKeyAsync(GetContractTemplateByKeyRequest request) async {
		var rpcRst = await call("GetContractTemplateDetailByKeyAsync", request);
		var result = ContractTemplateDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<PageCollection<ContractTemplateDTO>> getContractTemplatePageAsync(ContractTemplatePageRequest request) async {
		var rpcRst = await call("GetContractTemplatePageAsync", request);
		var result = PageCollection<ContractTemplateDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> removeContractTemplateAsync(RemoveContractTemplateRequest request) async {
		var rpcRst = await call("RemoveContractTemplateAsync", request);
		return rpcRst;
	}

	Future<List<ContractTemplateDTO>> getContractTemplateListAsync(GetContractTemplateListRequest request) async {
		var rpcRst = await call("GetContractTemplateListAsync", request);
		var result = (rpcRst as List).map((e)=>ContractTemplateDTO.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

	Future<bool> updateContractTemplateAsync(UpdateContractTemplateRequest request) async {
		var rpcRst = await call("UpdateContractTemplateAsync", request);
		return rpcRst;
	}

}

