import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalElectrocardiogram.m.dart';

import 'researchEdition.m.dart';


class VitalElectrocardiogramService extends JsonRpcClientBase {
	VitalElectrocardiogramService(
		String host, {
		String serviceName = "IVitalElectrocardiogramService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => ElectrocardiogramRecord.fromJson(map));
		FJsonConvert.setDecoder((map) => PageCollection<ElectrocardiogramRecord>.fromJson(map));
	}

	Future<ElectrocardiogramRecord> getElectrocardiogramRecordAsync(GetElectrocardiogramRecordRequest request) async {
		var rpcRst = await call("GetElectrocardiogramRecordAsync", request);
		var result = ElectrocardiogramRecord.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<PageCollection<ElectrocardiogramRecord>> getElectrocardiogramRecordPageAsync(ElectrocardiogramRecordPageRequest request) async {
		var rpcRst = await call("GetElectrocardiogramRecordPageAsync", request);
		var result = PageCollection<ElectrocardiogramRecord>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<ElectrocardiogramRecord> getElectrocardiogramRecordByPhysicalExamNumberAsync(GetElectrocardiogramRecordByPhysicalExamNumberRequest request) async {
		var rpcRst = await call("GetElectrocardiogramRecordByPhysicalExamNumberAsync", request);
		var result = ElectrocardiogramRecord.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> updateElectrocardiogramExamInfoRecordAsync(UpdateElectrocardiogramExamInfoRecordRequest request) async {
		var rpcRst = await call("UpdateElectrocardiogramExamInfoRecordAsync", request);
		return rpcRst;
	}

	Future<bool> removeElectrocardiogramAsync(GetElectrocardiogramRecordRequest request) async {
		var rpcRst = await call("RemoveElectrocardiogramAsync", request);
		return rpcRst;
	}

}

