import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalLogin.m.dart';

import 'researchEdition.m.dart';


class VitalLoginService extends JsonRpcClientBase {
	VitalLoginService(
		String host, {
		String serviceName = "IVitalLoginService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => LoginResult2.fromJson(map));
	}

	Future<LoginResult2> commonLoginAsync(CommonLoginRequest2 request) async {
		var rpcRst = await call("CommonLoginAsync", request);
		var result = LoginResult2.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> modifyPasswordAsync(ModifyPasswordRequest2 request) async {
		var rpcRst = await call("ModifyPasswordAsync", request);
		return rpcRst;
	}

	Future<bool> loginOutAsync(TokenRequest request) async {
		var rpcRst = await call("LoginOutAsync", request);
		return rpcRst;
	}

	Future<bool> verifyAccountAsync(VerifyAccountRequest2 request) async {
		var rpcRst = await call("VerifyAccountAsync", request);
		return rpcRst;
	}

}

