import 'login.m.dart';
import 'notification.m.dart';
import 'researchEdition.m.dart';

class LoginResult2 {
	LoginStateEnum loginState;
	String? token;
	String? accountName;

	LoginResult2({
		this.loginState = LoginStateEnum.Succeed,
		this.token,
		this.accountName,
	});

	factory LoginResult2.fromJson(Map<String, dynamic> map) {
		return LoginResult2( 
			loginState: LoginStateEnum.values.firstWhere((e) => e.index == map['LoginState']),
			token: map['Token'],
			accountName: map['AccountName'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		map['LoginState'] = loginState.index;
		if (token != null)
			map['Token'] = token;
		if (accountName != null)
			map['AccountName'] = accountName;
		return map;
	}
}

class CommonLoginRequest2 {
	String? anyAccount;
	String? anyCode;
	String? password;
	Map<String,String>? headerMap;
	LoginSource loginSource;
	String? installVersion;

	CommonLoginRequest2({
		this.anyAccount,
		this.anyCode,
		this.password,
		this.headerMap,
		this.loginSource = LoginSource.PC,
		this.installVersion,
	});

	factory CommonLoginRequest2.fromJson(Map<String, dynamic> map) {
		return CommonLoginRequest2( 
			anyAccount: map['AnyAccount'],
			anyCode: map['AnyCode'],
			password: map['Password'],
			headerMap: map['HeaderMap']?.cast<String,String>(),
			loginSource: LoginSource.values.firstWhere((e) => e.index == map['LoginSource']),
			installVersion: map['InstallVersion'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if (anyAccount != null)
			map['AnyAccount'] = anyAccount;
		if (anyCode != null)
			map['AnyCode'] = anyCode;
		if (password != null)
			map['Password'] = password;
		if (headerMap != null)
			map['HeaderMap'] = headerMap;
		map['LoginSource'] = loginSource.index;
		if (installVersion != null)
			map['InstallVersion'] = installVersion;
		return map;
	}
}

class CommonSignUpRequest2 {
	String? anyAccount;
	String? anyCode;
	String? password;
	Map<String,String>? headerMap;

	CommonSignUpRequest2({
		this.anyAccount,
		this.anyCode,
		this.password,
		this.headerMap,
	});

	factory CommonSignUpRequest2.fromJson(Map<String, dynamic> map) {
		return CommonSignUpRequest2( 
			anyAccount: map['AnyAccount'],
			anyCode: map['AnyCode'],
			password: map['Password'],
			headerMap: map['HeaderMap']?.cast<String,String>(),
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if (anyAccount != null)
			map['AnyAccount'] = anyAccount;
		if (anyCode != null)
			map['AnyCode'] = anyCode;
		if (password != null)
			map['Password'] = password;
		if (headerMap != null)
			map['HeaderMap'] = headerMap;
		return map;
	}
}

class ModifyPasswordRequest2 extends CommonSignUpRequest2{
	String? token;
	String? newPassword;

	ModifyPasswordRequest2({
		this.token,
		this.newPassword,
		String? anyAccount,
		String? anyCode,
		String? password,
		Map<String,String>? headerMap,
	}) : super(
			anyAccount: anyAccount,
			anyCode: anyCode,
			password: password,
			headerMap: headerMap,
		);

	factory ModifyPasswordRequest2.fromJson(Map<String, dynamic> map) {
		return ModifyPasswordRequest2( 
			token: map['Token'],
			newPassword: map['NewPassword'],
			anyAccount: map['AnyAccount'],
			anyCode: map['AnyCode'],
			password: map['Password'],
			headerMap: map['HeaderMap']?.cast<String,String>(),
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if (token != null)
			map['Token'] = token;
		if (newPassword != null)
			map['NewPassword'] = newPassword;
		return map;
	}
}

class VerifyAccountRequest2 {
	String? userName;

	VerifyAccountRequest2({
		this.userName,
	});

	factory VerifyAccountRequest2.fromJson(Map<String, dynamic> map) {
		return VerifyAccountRequest2( 
			userName: map['UserName'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = Map<String, dynamic>();
		if (userName != null)
			map['UserName'] = userName;
		return map;
	}
}


