import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';

import 'vitalRegion.m.dart';


class VitalRegionService extends JsonRpcClientBase {
	VitalRegionService(
		String host, {
		String serviceName = "IVitalRegionService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				);

	Future<bool> setRegionVisibleConfigAsync(SetRegionVisibleConfigRequest request) async {
		var rpcRst = await call("SetRegionVisibleConfigAsync", request);
		return rpcRst;
	}

	Future<List<int>> getRegionVisibleConfigAsync(GetRegionVisibleConfigRequest request) async {
		var rpcRst = await call("GetRegionVisibleConfigAsync", request);
		var result = (rpcRst as List).cast<int>().toList();
		return result;
	}

}

