import 'researchEdition.m.dart';

class SetRegionVisibleConfigRequest extends TokenRequest{
	List<int>? regionInfo;

	SetRegionVisibleConfigRequest({
		this.regionInfo,
		String? token,
	}) : super(
			token: token,
		);

	factory SetRegionVisibleConfigRequest.fromJson(Map<String, dynamic> map) {
		return SetRegionVisibleConfigRequest( 
			regionInfo: map['RegionInfo']?.cast<int>().toList(),
			token: map['Token'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		if (regionInfo != null)
			map['RegionInfo'] = regionInfo;
		return map;
	}
}

class GetRegionVisibleConfigRequest extends TokenRequest{

	GetRegionVisibleConfigRequest({
		String? token,
	}) : super(
			token: token,
		);

	factory GetRegionVisibleConfigRequest.fromJson(Map<String, dynamic> map) {
		return GetRegionVisibleConfigRequest( 
			token: map['Token'],
		);
	}

	Map<String, dynamic> toJson() {
		final map = super.toJson();
		return map;
	}
}


