import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalSchedule.m.dart';


class VitalScheduleService extends JsonRpcClientBase {
	VitalScheduleService(
		String host, {
		String serviceName = "IVitalScheduleService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => ClientScheduleDTO2.fromJson(map));
	}

	Future<List<ClientScheduleDTO2>> findSchedulesAsync(FindSchedulesRequest2 request) async {
		var rpcRst = await call("FindSchedulesAsync", request);
		var result = (rpcRst as List).map((e)=>ClientScheduleDTO2.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

}

