import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalTeamRegion.m.dart';

import 'researchEdition.m.dart';


class VitalTeamRegionService extends JsonRpcClientBase {
	VitalTeamRegionService(
		String host, {
		String serviceName = "IVitalTeamRegionService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => TeamRegionDTO.fromJson(map));
		FJsonConvert.setDecoder((map) => PageCollection<TeamRegionDTO>.fromJson(map));
	}

	Future<String> createTeamRegionAsync(CreateTeamRegionRequest request) async {
		var rpcRst = await call("CreateTeamRegionAsync", request);
		return rpcRst;
	}

	Future<TeamRegionDTO> getTeamRegionDetailAsync(GetTeamRegionRequest request) async {
		var rpcRst = await call("GetTeamRegionDetailAsync", request);
		var result = TeamRegionDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<TeamRegionDTO> getTeamRegionDetailByKeyAsync(GetTeamRegionByKeyRequest request) async {
		var rpcRst = await call("GetTeamRegionDetailByKeyAsync", request);
		var result = TeamRegionDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<PageCollection<TeamRegionDTO>> getTeamRegionPageAsync(TeamRegionPageRequest request) async {
		var rpcRst = await call("GetTeamRegionPageAsync", request);
		var result = PageCollection<TeamRegionDTO>.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> removeTeamRegionAsync(RemoveTeamRegionRequest request) async {
		var rpcRst = await call("RemoveTeamRegionAsync", request);
		return rpcRst;
	}

	Future<List<TeamRegionDTO>> getTeamRegionListAsync(GetTeamRegionListRequest request) async {
		var rpcRst = await call("GetTeamRegionListAsync", request);
		var result = (rpcRst as List).map((e)=>TeamRegionDTO.fromJson(e as Map<String, dynamic>)).toList();
		return result;
	}

	Future<bool> updateTeamRegionAsync(UpdateTeamRegionRequest request) async {
		var rpcRst = await call("UpdateTeamRegionAsync", request);
		return rpcRst;
	}

}

