import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'vitalUserPassword.m.dart';


class VitalUserPasswordService extends JsonRpcClientBase {
	VitalUserPasswordService(
		String host, {
		String serviceName = "IVitalUserPasswordService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				) {
		/// 注册响应实体反序列化处理器
		FJsonConvert.setDecoder((map) => UserPasswordDTO.fromJson(map));
	}

	Future<String> createUserPasswordAsync(CreateUserPasswordRequest request) async {
		var rpcRst = await call("CreateUserPasswordAsync", request);
		return rpcRst;
	}

	Future<UserPasswordDTO> getUserPasswordDetailAsync(GetUserPasswordRequest request) async {
		var rpcRst = await call("GetUserPasswordDetailAsync", request);
		var result = UserPasswordDTO.fromJson(rpcRst as Map<String, dynamic>);
		return result;
	}

	Future<bool> updateUserPasswordAsync(UpdateUserPasswordRequest request) async {
		var rpcRst = await call("UpdateUserPasswordAsync", request);
		return rpcRst;
	}

}

